<template>
    <div class="photo-viewer" :style="{'border-color': borderColor}" v-if="!!navigator.mediaDevices && !!navigator.mediaDevices.getUserMedia">
        <video ref="camera" autoplay playsinline muted />
        <div v-if="$slots.default" class="overlay-title px-2 py-1 mx-auto">
            <slot></slot>
        </div>
    </div>
    <div v-else class="not-supported">
        Camera not supported.
    </div>
</template>

<style lang="scss" scoped>
.photo-viewer {
    position: relative;
    display: inline-block;
    border: solid 2px;
    width: 25vw;
    height: 25vh;
    margin: 0px;
    padding: 0px;
    background-color: black;
}

.photo-viewer img {
    height: 100%;
    width: 100%;
    position:absolute;
    left:0;
}

.photo-viewer .overlay-title {
    line-height: normal;
    position: absolute;
    display: flex;
    bottom: 5px;
    border-radius: 3px;
    background: #333333;
    border: white solid 2px;
    max-width: 80%;
    left: 50%;
    -webkit-transform: translateX(-50%);
    transform: translateX(-50%);
    color: white;
}
</style>

<script>
export default {
    props: {
        "src": String,
        "live": Boolean,
        "preview": Boolean,
    },
    mounted(){
        const videoInputs = [];
        navigator.mediaDevices.enumerateDevices().then(devices => {
            for (device in devices){
                if (device.kind == 'videoinput'){
                    videoInputs.push(device);
                }
            }
        });

        // filter for only videoinput, get deviceId
        const camera1ID = videoInputs[0];
        const stream = navigator.mediaDevices.getUserMedia({
            video: {
                deviceId: {
                    exact: camera1ID,
                },
            },
        });
        this.$refs.camera.srcObject = stream;
    },
    computed: {
        borderColor(){
            if (this.live) return "red";
            if (this.preview) return "#00CC00";
            return "white";
        },
    },
};
</script>
